$(document).ready(function(){

  // Launch query when clicking on the search button.
  $("#search-button").click(launchQuery);

  // Hide the search buttton (we don't really need it when we have search as you
  // type).
  $("#search-button").hide();

  // Launch query upon every keystroke.
  $("#search-field").keyup(launchQuery);
    
  // Get query from search field and send it to backend, using prefix-search.php
  // as a proxy. Sending of the result happens ansynchronously: this function
  // ends upon sending the query, and when the result has arrived, function
  // processResult is called, with the result XML as argument.
  // Note: We can't talk to the server directly, because JavaScript
  // does not allow that.
  function launchQuery()
  {
    var query = $("#search-field").attr("value") + "*";
    $.get("http://stromboli.informatik.uni-freiburg.de/prefix-search.php/?q=" + query,
          { },
          processResult);
  }

  // Process the results XML. Extracts the completions and hits, and shows them
  // in the corresponding divs on the html page.
  function processResult(xml)
  {
    // Extract the completions and show them.
    var completions = $(xml).find("c");
    var completionsAsHtml = "Completions: ";
    for (var i = 0; i < completions.length; ++i)
    {
      completionsAsHtml += (i > 0 ? ", " : "" ) + completions.eq(i).text();
    }
    $("#completions").html(completionsAsHtml);

    // Extract the hits and show them.
    var hits = $(xml).find("hit");
    var hitsAsHtml = "";
    for (var i = 0; i < hits.length; ++i)
    {
      var hit = "Hit #" + (i+1) + ": " +
                "<a href=\"" + hits.eq(i).find("url").text() + "\">" +
                hits.eq(i).find("title").text() + "</a><br>"; 
      hitsAsHtml += hit;
    }
    $("#hits").html(hitsAsHtml);
  }

});
